#include "clause_index.h"

void LITERAL_INDEX::Destroy()
 {
  DCONTROL2("BEGIN in LITERAL_INDEX::Destroy()");
  TERM prop_lit; 
  for (int prop_var = 0; prop_var < MAX_NUMBER_OF_FUNCTORS; prop_var++)
   {
    DCONTROL2("C10 in LITERAL_INDEX::Destroy()");
    prop_lit.MakeComplex((ARITY)0,(FUNCTOR)prop_var,POL_POS);
    DCONTROL2("C20 in LITERAL_INDEX::Destroy()");
    *(Share(prop_lit)->InfoField()) = (void*)0; // temporary
    DCONTROL2("C30 in LITERAL_INDEX::Destroy()");   
    prop_lit.InversePolarity();
    DCONTROL2("C40 in LITERAL_INDEX::Destroy()");
    *(Share(prop_lit)->InfoField()) = (void*)0; // temporary
    DCONTROL2("C50 in LITERAL_INDEX::Destroy()");
   }; 
  DCONTROL2("C60 in LITERAL_INDEX::Destroy()");
  for (int i = 0; i < MAX_NUMBER_OF_FUNCTORS; i++)
   {
    DCONTROL2("C70 in LITERAL_INDEX::Destroy()");

    DTREE::Destroy(positive[i],DestroyLeafContent);

    DCONTROL2("C80 in LITERAL_INDEX::Destroy()");
    positive[i] = (DTREE_NODE*)0;
    DCONTROL2("C90 in LITERAL_INDEX::Destroy()");
   };

  DCONTROL2("C100 in LITERAL_INDEX::Destroy()");

  for (int j = 0; j < MAX_NUMBER_OF_FUNCTORS; j++)
   {
    DCONTROL2("C110 in LITERAL_INDEX::Destroy()");
    DTREE::Destroy(negative[j],DestroyLeafContent);
    DCONTROL2("C120 in LITERAL_INDEX::Destroy()");
    negative[j] = (DTREE_NODE*)0;
    DCONTROL2("C130 in LITERAL_INDEX::Destroy()"); 
   };  
  DCONTROL2("END in LITERAL_INDEX::Destroy()"); 
 }; //void LITERAL_INDEX::Destroy()  

void LITERAL_INDEX::DestroyLeafContent(DTREE_NODE* leaf)
 {  
   // cout << "DESTR\n"; ::Output(*(leaf->Term())); cout << "\n"; // debug
  if (leaf->Term()->Arity()) 
   leaf->Term()->DeleteLit();
  //ORD_CLAUSE_LIST::Destroy(leaf->Clauses());
 }; // void LITERAL_INDEX::DestroyLeafContent(DTREE_NODE* leaf)


//*******************************************************************************
