#ifndef __OUTPUT_H
 #include "output.h"
#endif

#define  __DEBUG_H 


 
//#define _DEBUG_  
//#define _DEBUG0_   
//#define _DEBUG1_
//#define _DEBUG2_
//#define _DEBUG3_
//#define _DEBUG4_
//#define _DEBUG5_
//#define _DEBUG6_
//#define _DEBUG7_   // forward subsumption
//#define _DEBUG8_ // tmp_literal.h, resolvent.h and new_clause.h
//#define _DEBUG9_ // flat_term.h
//#define _DEBUG10_ // new_clause.h and tmp_lit_list.h
//#define _DEBUG11_ // binary_resolution.h
//#define _DEBUG12_ // equivalence_relation.h
//#define _DEBUG13_ // or_machine.h 
//#define _DEBUG14_ // bs_machine.h and bs_machine.cc
//#define _DEBUG15_ // or_index.h and or_index.cc 
//#define _DEBUG16_ // para_machine.h
//#define _DEBUG17_ // superposition.h
//#define _DEBUG18_ // weight_formula.h
//#define _DEBUG19_ // mi_tree.h and mi_tree.cc
//#define _DEBUG20_ // m_index.h and forw_ueq_simplification.h
//#define _DEBUG21_ // b_matching.h and back_demodulation.h
 
//#define _DEBUG_MEMORY_  
#ifndef _DEBUG_
 #undef _DEBUG_MEMORY_
#endif

#ifdef _DEBUG_

extern ofstream dout;
  
void InitDebug();

void DEBUG_CONTROL_POINT(const char* const p);

void REPORT_CONTROL_POINT();

void DebugError(const char* msg);
void DebugError(const char* msg1,const char* msg2,const char* msg3);

#endif

void RuntimeError(const char* msg);
void RuntimeError(const char* msg1,const char* msg2,const char* msg3);

#ifdef _DEBUG_
 #define DEBUG_OUTPUT(msg) { cout << msg; };
 #define DOUT(msg) { dout << msg; };
#else
 #define DEBUG_OUTPUT(msg) {};
 #define DOUT(msg) {};
#endif


#ifdef _DEBUG0_
 #define CHECK0(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK0(cond,msg) { };
#endif

#ifdef _DEBUG0_
 #define DEBUG0_OP(op) op 
#else
 #define DEBUG0_OP(op) {}
#endif

#ifdef _DEBUG0_
 #define DCONTROL0(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL0(p) {}
#endif


#ifdef _DEBUG1_
 #define CHECK1(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK1(cond,msg) { };
#endif

#ifdef _DEBUG1_
 #define DEBUG1_OP(op) op 
#else
 #define DEBUG1_OP(op) {}
#endif

#ifdef _DEBUG1_
 #define DCONTROL1(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL1(p) {}
#endif 
 
#ifdef _DEBUG2_
 #define CHECK2(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK2(cond,msg) { };
#endif 

#ifdef _DEBUG2_
 #define DEBUG2_OP(op) op 
#else
 #define DEBUG2_OP(op) {}
#endif
 
#ifdef _DEBUG2_
 #define DCONTROL2(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL2(p) {}
#endif

#ifdef _DEBUG3_
 #define CHECK3(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK3(cond,msg) { };
#endif 

#ifdef _DEBUG3_
 #define DEBUG3_OP(op) op 
#else
 #define DEBUG3_OP(op) {}
#endif
 
#ifdef _DEBUG3_
 #define DCONTROL3(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL3(p) {}
#endif



#ifdef _DEBUG4_
 #define CHECK4(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK4(cond,msg) { };
#endif 

#ifdef _DEBUG4_
 #define DEBUG4_OP(op) op 
#else
 #define DEBUG4_OP(op) {}
#endif
 
#ifdef _DEBUG4_
 #define DCONTROL4(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL4(p) {}
#endif




#ifdef _DEBUG5_
 #define CHECK5(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK5(cond,msg) { };
#endif 

#ifdef _DEBUG5_
 #define DEBUG5_OP(op) op 
#else
 #define DEBUG5_OP(op) {}
#endif
 
#ifdef _DEBUG5_
 #define DCONTROL5(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL5(p) {}
#endif



#ifdef _DEBUG6_
 #define CHECK6(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK6(cond,msg) { };
#endif 

#ifdef _DEBUG6_
 #define DEBUG6_OP(op) op 
#else
 #define DEBUG6_OP(op) {}
#endif
 
#ifdef _DEBUG6_
 #define DCONTROL6(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL6(p) {}
#endif 

#ifdef _DEBUG7_
 #define CHECK7(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK7(cond,msg) { };
#endif 

#ifdef _DEBUG7_
 #define DEBUG7_OP(op) op 
#else
 #define DEBUG7_OP(op) {}
#endif
 
#ifdef _DEBUG7_
 #define DCONTROL7(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL7(p) {}
#endif  
 


#ifdef _DEBUG8_
 #define CHECK8(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK8(cond,msg) { };
#endif 

#ifdef _DEBUG8_
 #define DEBUG8_OP(op) op 
#else
 #define DEBUG8_OP(op) {}
#endif
 
#ifdef _DEBUG8_
 #define DCONTROL8(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL8(p) {}
#endif  
  
  
#ifdef _DEBUG9_
 #define CHECK9(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK9(cond,msg) { };
#endif 

#ifdef _DEBUG9_
 #define DEBUG9_OP(op) op 
#else
 #define DEBUG9_OP(op) {}
#endif
 
#ifdef _DEBUG9_
 #define DCONTROL9(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL9(p) {}
#endif  
   

#ifdef _DEBUG10_
 #define CHECK10(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK10(cond,msg) { };
#endif 

#ifdef _DEBUG10_
 #define DEBUG10_OP(op) op 
#else
 #define DEBUG10_OP(op) {}
#endif
 
#ifdef _DEBUG10_
 #define DCONTROL10(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL10(p) {}
#endif   
 

#ifdef _DEBUG11_
 #define CHECK11(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK11(cond,msg) { };
#endif 

#ifdef _DEBUG11_
 #define DEBUG11_OP(op) op 
#else
 #define DEBUG11_OP(op) {}
#endif
 
#ifdef _DEBUG11_
 #define DCONTROL11(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL11(p) {}
#endif    


#ifdef _DEBUG12_
 #define CHECK12(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK12(cond,msg) { };
#endif 

#ifdef _DEBUG12_
 #define DEBUG12_OP(op) op 
#else
 #define DEBUG12_OP(op) {}
#endif
 
#ifdef _DEBUG12_
 #define DCONTROL12(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL12(p) {}
#endif    


#ifdef _DEBUG13_
 #define CHECK13(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK13(cond,msg) { };
#endif 

#ifdef _DEBUG13_
 #define DEBUG13_OP(op) op 
#else
 #define DEBUG13_OP(op) {}
#endif
 
#ifdef _DEBUG13_
 #define DCONTROL13(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL13(p) {}
#endif    
  

#ifdef _DEBUG14_
 #define CHECK14(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK14(cond,msg) { };
#endif 

#ifdef _DEBUG14_
 #define DEBUG14_OP(op) op 
#else
 #define DEBUG14_OP(op) {}
#endif
 
#ifdef _DEBUG14_
 #define DCONTROL14(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL14(p) {}
#endif 



#ifdef _DEBUG15_
 #define CHECK15(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK15(cond,msg) { };
#endif 

#ifdef _DEBUG15_
 #define DEBUG15_OP(op) op 
#else
 #define DEBUG15_OP(op) {}
#endif
 
#ifdef _DEBUG15_
 #define DCONTROL15(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL15(p) {}
#endif 



#ifdef _DEBUG16_
 #define CHECK16(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK16(cond,msg) { };
#endif 

#ifdef _DEBUG16_
 #define DEBUG16_OP(op) op 
#else
 #define DEBUG16_OP(op) {}
#endif
 
#ifdef _DEBUG16_
 #define DCONTROL16(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL16(p) {}
#endif 

  

#ifdef _DEBUG17_
 #define CHECK17(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK17(cond,msg) { };
#endif 

#ifdef _DEBUG17_
 #define DEBUG17_OP(op) op 
#else
 #define DEBUG17_OP(op) {}
#endif
 
#ifdef _DEBUG17_
 #define DCONTROL17(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL17(p) {}
#endif   
    
    

#ifdef _DEBUG18_
 #define CHECK18(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK18(cond,msg) { };
#endif 

#ifdef _DEBUG18_
 #define DEBUG18_OP(op) op 
#else
 #define DEBUG18_OP(op) {}
#endif
 
#ifdef _DEBUG18_
 #define DCONTROL18(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL18(p) {}
#endif       
    


#ifdef _DEBUG19_
 #define CHECK19(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK19(cond,msg) { };
#endif 

#ifdef _DEBUG19_
 #define DEBUG19_OP(op) op 
#else
 #define DEBUG19_OP(op) {}
#endif
 
#ifdef _DEBUG19_
 #define DCONTROL19(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL19(p) {}
#endif  

#ifdef _DEBUG20_
 #define CHECK20(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK20(cond,msg) { };
#endif 

#ifdef _DEBUG20_
 #define DEBUG20_OP(op) op 
#else
 #define DEBUG20_OP(op) {}
#endif
 
#ifdef _DEBUG20_
 #define DCONTROL20(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL20(p) {}
#endif      


#ifdef _DEBUG21_
 #define CHECK21(cond,msg) { if (!(cond)) { DebugError(msg); }; };
#else
 #define CHECK21(cond,msg) { };
#endif 

#ifdef _DEBUG21_
 #define DEBUG21_OP(op) op 
#else
 #define DEBUG21_OP(op) {}
#endif
 
#ifdef _DEBUG21_
 #define DCONTROL21(p) { DEBUG_CONTROL_POINT(p); };
#else
 #define DCONTROL21(p) {}
#endif      

 
void DebugWarning(const char* msg);
 
//***************************************************************************** 
 
 
 
 
