
#define __OUTPUT_H

#include <fstream.h>


class TERM;
class Clause;
//class FORMULA; 
class ANCESTORS;

extern bool output_to_file;
extern bool tabulate_to_file;
extern char* output_file_name;
extern char* tabulation_file_name;
extern long tabulated_file_name_width;

void AdjustOutput();
void CloseOutput();
 
void Output(char);
void Output(int);
void Output(long);
void Output(unsigned short);
void Output(unsigned long);
void Output(float);
void Output(double);
void Output(const char*);
void Output(const Clause*);
void Output(ANCESTORS* p);
void Output(const TERM*);
void OutputTerm(const TERM*);
//void Output(const FORMULA*);
void Output(void*);		// just for debugging
void OutputInference(Clause* root);

 
//void OpenTabulation();
//void CloseTabulation();
void TabulateFileName(char*);
void TabulateTime(float);
void TabulateMemory(long);
void TabulateChar(char);
void TabulateString(const char* const);
void TabulateLong(long s);

void OutputVar(int var);

void OutputFunctor(int func);

void OutputEqLit(const TERM* lit);

void Output(const TERM& t);

 

//***********************************************************************






