#define __PARA_MACHINE_H

#ifndef __DEBUG_H
 #include "debug.h"
#endif
#ifndef __VAMPIRE_H
 #include "vampire.h"
#endif 
#ifndef __IU_COMMAND_H
 #include "iu_command.h"
#endif 
#ifndef __PREFIX_H
 #include "prefix.h"
#endif
#ifndef __VARIABLES_H
 #include "variables.h"
#endif
#ifndef __OR_INDEX_H
 #include "or_index.h"
#endif
#ifndef __IU_MACHINE_H
 #include "iu_machine.h"
#endif 
//#ifndef __RESOLVENT_H
// #include "resolvent.h"
//#endif

//extern RESOLVENT Resolvent;
extern OR_INDEX ORIndex;

//**************************************************************************

class PARA_MACH : private IU_MACH
 {
  public: 
   PARA_MACH() : IU_MACH() {};
   inline void SetIndex(int ind) { IU_MACH::SetIndex(ind); };
   inline int GetIndex() const { return IU_MACH::GetIndex(); };
   inline void CompileComplexTerm(PREFIX_SYM* t)
    {
     IU_MACH::CompileLiteral(t);
    };
   inline void CompilePseudoLiteral(TERM header,PREFIX_SYM* t)
    {
     IU_MACH::CompilePseudoLiteral(header,t);
    }; 
   inline bool FindFirstLeaf(OR_INDEX_TREE_NODE* tree) 
    {
     return IU_MACH::FindFirstLeaf(tree); 
    }; 
   inline bool FindNextLeaf() { return IU_MACH::FindNextLeaf(); };
   inline void ResetCandidatesFromLeaf() { IU_MACH::ResetCandidatesFromLeaf(); };
   inline RES_PAIR_LIST* NextCandidateFromTheLeaf() { return IU_MACH::NextCandidate(); };
   inline bool VariablesFromIndexAffected() { return IU_MACH::VariablesFromIndexAffected(); };
  public: // for debugging
   inline void OutputCode()
    {
     IU_MACH::OutputCode();
    };
 }; // class PARA_MACH : private IU_MACH


//**************************************************************************




























