#include <iostream.h>
#include <ctype.h>
#include <signal.h>
#include <setjmp.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>


#include "vampire.h"
#include "output.h"
#include "readcmd.h"
#include "command.h"


// needed to handle ^C interrupts during command reading
jmp_buf jumper;

void Jump(int)
 {
  longjmp(jumper,1);
 };

bool ExecuteRuntimeCommand(char* buff) 
 {
  if (buff) {};
  return false; 
 }; // temporary

void ReadLine(int)
{
  char buffer[1000];

  begin:
  int jump_happened = setjmp(jumper);
  signal(SIGINT,Jump);

  // if real_jump != 0 here, then exit was by a jump
  if (jump_happened)
    goto begin;

  Output("Vampire: ");
  cin.getline(buffer,1000);

  if (!ExecuteRuntimeCommand(buffer))
    goto begin;

  // at the exit just reset ^C interrupt to the default value
  signal(SIGINT,ReadLine);
}  // CtrlBrk()


void InitializeCtrlBrk()
 {
  signal(SIGINT,ReadLine);
 };
 

extern char *problemFileName;  
void Exit(const char* msg)
 {
  Output(msg);
  Output('\n');
  CloseOutput();
  exit(EXIT_SUCCESS);
 };  // Exit()

//***********************************************************************
