#include "statistics.h"
 
#ifndef __OUTPUT_H
 #include "output.h"
#endif

long STATISTICS_ON_GENERATED::generated = 0L;
long STATISTICS_ON_GENERATED::tautology = 0L;
long STATISTICS_ON_GENERATED::forward_subsumed = 0L;
long STATISTICS_ON_GENERATED::simplified_resolvents = 0L;

long STATISTICS_ON_GENERATED::too_heavy_term = 0L;
long STATISTICS_ON_GENERATED::too_deep = 0L;
long STATISTICS_ON_GENERATED::too_heavy_clause = 0L;
long STATISTICS_ON_GENERATED::too_long_clause = 0L;
long STATISTICS_ON_GENERATED::too_many_variables = 0L;
long STATISTICS_ON_GENERATED::rejected_by_kept = 0L;
long STATISTICS_ON_GENERATED::purged_from_kept = 0L;

//************* Definitions for STATISTICS_ON_GENERATED: ************

void STATISTICS_ON_GENERATED::Output()
 {
  ::Output("****** STATISTICS ON GENERATED CLAUSES:\n");
  ::Output("          generated                "); ::Output(generated); ::Output('\n'); 
  ::Output("          tautologies              "); ::Output(tautology); ::Output('\n');
  ::Output("          forward subsumed         "); ::Output(forward_subsumed); ::Output('\n');
  ::Output("          simplified resolvents    "); ::Output(simplified_resolvents); ::Output('\n');
  ::Output("          too heavy                "); ::Output(too_heavy_clause); ::Output('\n');
  ::Output("          too long                 "); ::Output(too_long_clause); ::Output('\n');
  ::Output("          with too heavy literals  "); ::Output(too_heavy_term); ::Output('\n');
  ::Output("          too deep                 "); ::Output(too_deep); ::Output('\n');
  ::Output("          with too many variables  "); ::Output(too_many_variables); ::Output('\n');
  ::Output("          rejected by kept         "); ::Output(rejected_by_kept); ::Output('\n');
  ::Output("          purged from kept         "); ::Output(purged_from_kept); ::Output('\n');
 }; // void STATISTICS_ON_GENERATED::Output()


//*************************************************************************
