#define __HASH_TABLE_H
#ifndef __DEBUG_H
 #include "debug.h"
#endif
#ifndef __VAMPIRE_H
 #include "vampire.h"
#endif
#ifndef __MEMORY_H
 #include "memory.h"
#endif

//**********************************************************************

template <int SIZE,class LIST>
 class HASH_TABLE
  {
   private:
    LIST table[SIZE];
   public:
    HASH_TABLE(const LIST& x) { Init(x); };
    inline void Init(const LIST& x) 
     {
      for (int i = 0; i<SIZE; i++)
       {
        table[i] = x;
       }; 
     };
    inline LIST& List(long key)
     {
      return table[key % SIZE];  
     };
    
    inline int Size() const { return SIZE; };
  }; // class HASH_TABLE<int Size,class LIST>



//*********************************************************************
